
#@# timeout: 8
#@# interval: 60

use Net::SMTP;
use DB_File;
use Math::TrulyRandom;
use Socket;

my $arg = shift;

my ($addr, $user);

my $hostname;
if (ref($arg)) {
    $addr = $arg->{'addr'};
    $user = $arg->{'user'};
    $hostname = $arg->{'name'};
} else {
    $addr = $arg;
    $user = shift;
    $hostname = gethostbyaddr(inet_aton($addr), AF_INET);
}


srand(truly_random_value());
my $random = rand 10000;
my $messageID = "<$random.".time."\@gameserver.dm.berlin.ccc.de>";

my %sentMessages;	# messages sent by the smtp server (indexed by msgid)
tie %sentMessages, 'DB_File', 'smtp-sent.db', O_RDWR | O_CREAT, 0644, $DB_HASH
    or die "smtp: can't open/create db file smtp-sent.db: $!\n";

my $smtp = new Net::SMTP($addr, Debug => 1);

if (not defined $smtp) {
    die "smtp: can't connect to SMTP server\n";
}

warn "$0: connected\n";

$smtp->mail('deathmatch@gameserver.dm.berlin.ccc.de')
    or die "smtp: failed on MAIL FROM: ", $smtp->message;
$smtp->to("$user\@$hostname")
    or die "smtp: failed on RCPT TO: ", $smtp->message;
$smtp->data(join("\r\n", split(/\n/, <<MAIL
Message-Id: $messageID
Subject: $addr
From: deathmatch\@gameserver.dm.berlin.ccc.de
To: $user\@$hostname

MAIL
			))) 
    or die "smtp: failed on DATA: ", $smtp->message;
$smtp->quit()
    or die "smtp: failed on QUIT: ", $smtp->message;

$sentMessages{$messageID} = 'open';

print STDERR "smtp: message sent\n";

